	<%@ Language=VBScript %>
	
	<!--#include file="db_conn_open.asp"-->
	<!--#include file="includes.asp"-->
	<!--#include file="inc/languageadmin.asp"-->
	<!--#include file="inc/incfunctions.asp"-->
	<!--#include file="thubsettings.asp"-->
	
	
	<%
	' ------------------------------------------------------------------------------------------
	'  $Id: thubservice.php$
	'  for ecommercetemplates
	  
	'  Implemented by
	'  Atandra Systems
	'  www.atandra.com
	  
	'  Copyright (c) 2006 www.atandra.com
	'  Released under the GNU General Public License
	' ------------------------------------------------------------------------------------------
	

	
	Dim connTemp
	Dim requestInfo
	Dim requestDoc
	Dim responseDoc
	Dim requestRoot
	Dim envelopeNode
	Dim userIdNode
	Dim passwordNode
	Dim commandNode
	Dim statusCodeNode
	Dim statusMessageNode
	Dim requestIDNode
	Dim providerNode
	Dim orderCountNode
	dim noOfDaysNode
	Dim excludeOrdersNode
	Dim orderStartNumberNode
	Dim strStatusCode
	Dim strStatusMessage
	Dim strCommandValue
	Dim strRequestID
	Dim strExcludeOrders
	Dim QB_ORDERS_PER_RESPONSE
	Dim QB_ORDER_START_NUMBER
	Dim QB_NUMBER_OF_DAYS
	Dim noOfOrdersAffected
	Dim isValidUser
	Dim strResponse
	Dim gv_cartPriceDiff
	
	Dim STORE_NAME
	Dim STORE_NAME_ID

	
	requestInfo = Request.Form("request")
	
	Set requestDoc = Server.CreateObject("MSXML2.DOMDocument")
	If requestDoc Is Nothing Then
		Response.Write ("Unable to create XML documnet")
		Response.End
	End If
	
	
	requestDoc.async = False
	requestDoc.loadXML(requestInfo)
	Set requestRoot = requestDoc.documentElement
	If requestRoot Is Nothing Then
		Response.Write ("Invalid XML Request")
		Response.End
	End If
	
	isValidUser = False
	strCommandValue = ""
	strRequestID = ""
	QB_ORDERS_PER_RESPONSE = ""
	QB_ORDER_START_NUMBER = ""
	QB_NUMBER_OF_DAYS = ""
	
	'Set Comment
	Set commandNode = requestRoot.selectSingleNode("/REQUEST/Command")
	If Not commandNode Is Nothing Then
		strCommandValue = commandNode.Text    
	End If
	
	'set Request ID
	Set requestIDNode = requestRoot.selectSingleNode("/REQUEST/RequestID")
	If Not requestIDNode Is Nothing Then
		strRequestID = requestIDNode.Text
	End If
	
	
	Set responseDoc = Server.CreateObject("MSXML2.DOMDocument")
	Set responseDoc.documentElement = responseDoc.createElement("RESPONSE")
	responseDoc.documentElement.setAttribute "version", "1.0"
	responseDoc.documentElement.setAttribute "encoding", "ISO-8859-1"
	
	'create the envelope
	Set envelopeNode = responseDoc.createElement("Envelope")
	responseDoc.documentElement.appendChild envelopeNode
	
	'set the command
	Set commandNode = responseDoc.createElement("Command")
	commandNode.Text = strCommandValue
	envelopeNode.appendChild commandNode
	
	'set the status code and message
	Set statusCodeNode = responseDoc.createElement("StatusCode")
	envelopeNode.appendChild statusCodeNode
	Set statusMessageNode = responseDoc.createElement("StatusMessage")
	envelopeNode.appendChild statusMessageNode
	
	'set the request id
	Set requestIDNode = responseDoc.createElement("RequestID")
	envelopeNode.appendChild requestIDNode
	requestIDNode.Text = strRequestID
	
	'set the provider
	Set providerNode = responseDoc.createElement("Provider")
	envelopeNode.appendChild providerNode
	providerNode.Text = "GENERIC"
	
	'get the order count
	Set orderCountNode = requestRoot.selectSingleNode("/REQUEST/LimitOrderCount")
	If Not orderCountNode Is Nothing Then
		QB_ORDERS_PER_RESPONSE = orderCountNode.Text
	End If
	If QB_ORDERS_PER_RESPONSE = "" Then
		QB_ORDERS_PER_RESPONSE = 25
	End If
	
	'get the order count
	Set noOfDaysNode = requestRoot.selectSingleNode("/REQUEST/NumberOfDays")
	If Not noOfDaysNode Is Nothing Then
		QB_NUMBER_OF_DAYS = noOfDaysNode.Text
	End If
	If QB_NUMBER_OF_DAYS = "" Then
		QB_NUMBER_OF_DAYS = 10
	End If
	
	'get the start order number
	Set orderStartNumberNode = requestRoot.selectSingleNode("/REQUEST/OrderStartNumber")
	If Not orderStartNumberNode Is Nothing Then
		QB_ORDER_START_NUMBER = orderStartNumberNode.Text
	End If
	If QB_ORDER_START_NUMBER = "" Then
		QB_ORDER_START_NUMBER = 0
	End If
	
	'Set excludeOrdersNode = requestRoot.selectSingleNode("/REQUEST/exclude-orders")
	'If Not excludeOrdersNode Is Nothing Then
	'    strExcludeOrders = excludeOrdersNode.Text
	'End If
		
	Set userIdNode = requestRoot.selectSingleNode("/REQUEST/UserID")
	Set passwordNode = requestRoot.selectSingleNode("/REQUEST/Password")
	If Not userIdNode Is Nothing And Not passwordNode Is Nothing Then
		isValidUser = ValidateUser(userIdNode.Text, passwordNode.Text)
	Else
		strStatusCode = "9000"
		strStatusMessage = "Order download service authentication failure - Login/Password supplied did not match"
	End If
	
	If isValidUser Then
		If strCommandValue = "GetOrders" Then    
			noOfOrdersAffected = GetOrders(strOrderStartNumber, strOrderCount)
			If noOfOrdersAffected = 0 Then
				strStatusCode = 1000
				strStatusMessage = "No Orders returned"
			ElseIf noOfOrdersAffected > 0 Then
				strStatusCode = 0
				strStatusMessage = "All OK"
			Else
				strStatusCode = 9999
				strStatusMessage = "Other Error"
			End If
		ElseIf strCommandValue = "UpdateOrders" Then
			noOfOrdersAffected = UpdateOrders(requestDoc, responseDoc)
			If noOfOrdersAffected > 0 Then
				strStatusCode = 0
				strStatusMessage = "All OK"
			Else
				strStatusCode = 9999
				strStatusMessage = "Other Error"
			End If
		ElseIf strCommandValue = "UpdateOrdersShippingStatus" Then
			noOfOrdersAffected = UpdateOrdersShipped(requestDoc, responseDoc)
			If noOfOrdersAffected > 0 Then
				strStatusCode = 0
				strStatusMessage = "All OK"
			Else
				strStatusCode = 9999
				strStatusMessage = "Other Error Shipped"
			End If
		End If
	Else
		strStatusCode = "9000"
		strStatusMessage = "Login failed" 
	End If
	
	statusCodeNode.Text = strStatusCode
	statusMessageNode.Text = strStatusMessage
	
	strResponse = responseDoc.xml
	FOR asciiCode = 128 to 255
		strResponse = Replace(strResponse, Chr(asciiCode), "")
	NEXT
	
	Response.ContentType = "text/xml"
	Response.Write(strResponse)
	
	Private Function UpdateOrdersShipped(requestDoc, responseDoc)
	
		Dim ordersNode
		Dim orderNode
		Dim requestOrderNode
		Dim childNode
		Dim requestOrderNodeList
		Dim strHostOrderId
		Dim strLocalOrderId
		Dim strLocalOrderRef
		Dim strLocalStatus
		Dim noOfOrdersUpdated
		Dim rowsAffected
		Dim trackNumber
			Dim ServiceUsed
			Dim ShippedVia
			
		noOfOrdersUpdated = 0
	
		Set requestOrderNodeList = requestDoc.getElementsByTagName("Order")
		
		Set ordersNode = responseDoc.createElement("Orders")
		responseDoc.documentElement.appendChild ordersNode
	
		For Each requestOrderNode In requestOrderNodeList
	
			strHostOrderId = requestOrderNode.selectSingleNode("./HostOrderID").Text
			strLocalOrderId = requestOrderNode.selectSingleNode("./LocalOrderID").Text
					trackNumber = requestOrderNode.selectSingleNode("./TrackingNumber").Text
					ServiceUsed = requestOrderNode.selectSingleNode("./ServiceUsed").Text
					ShippedVia = requestOrderNode.selectSingleNode("./ShippedVia").Text
					
					
			'If LCase(strLocalStatus) = LCase("Processed") Then
			
				rowsAffected = UpdateOrderShipped(strLocalOrderId, strHostOrderId, trackNumber, ShippedVia, ServiceUsed)
				
				Set orderNode = responseDoc.createElement("Order")
				ordersNode.appendChild orderNode
				
				'set host order id
				Set childNode = responseDoc.createElement("HostOrderID")
				orderNode.appendChild childNode
				childNode.Text = strHostOrderId
				
				'set local order id
				Set childNode = responseDoc.createElement("LocalOrderID")
				orderNode.appendChild childNode
				childNode.Text = strLocalOrderId
				
				'set local order ref
				Set childNode = responseDoc.createElement("LocalOrderRef")
				orderNode.appendChild childNode
				childNode.Text = strLocalOrderRef
				
				'set host status
				Set childNode = responseDoc.createElement("HostStatus")
				orderNode.appendChild childNode
				If rowsAffected >= 1 Then
					childNode.Text = "Success"
					noOfOrdersUpdated = noOfOrdersUpdated + rowsAffected
				Else
					childNode.Text = "Failed"
				End If
			'End If
		Next
		
		UpdateOrdersShipped = noOfOrdersUpdated
		
	End Function
	
	
	'This function updates the order information in the db
	Private Function UpdateOrders(requestDoc, responseDoc)
	
		Dim ordersNode
		Dim orderNode
		Dim requestOrderNode
		Dim childNode
		Dim requestOrderNodeList
		Dim strHostOrderId
		Dim strLocalOrderId
		Dim strLocalOrderRef
		Dim strLocalStatus
		Dim noOfOrdersUpdated
		Dim rowsAffected
	
		noOfOrdersUpdated = 0
	
		Set requestOrderNodeList = requestDoc.getElementsByTagName("Order")
		
		Set ordersNode = responseDoc.createElement("Orders")
		responseDoc.documentElement.appendChild ordersNode
	
		For Each requestOrderNode In requestOrderNodeList
		
			strHostOrderId = requestOrderNode.selectSingleNode("./HostOrderID").Text
			strLocalOrderId = requestOrderNode.selectSingleNode("./LocalOrderID").Text
			strLocalOrderRef = requestOrderNode.selectSingleNode("./LocalOrderRef").Text
			strLocalStatus = requestOrderNode.selectSingleNode("./LocalStatus").Text
	
			If LCase(strLocalStatus) = LCase("Processed") Then
			
				rowsAffected = UpdateOrder(strLocalOrderId, strHostOrderId)
				
				Set orderNode = responseDoc.createElement("Order")
				ordersNode.appendChild orderNode
				
				'set host order id
				Set childNode = responseDoc.createElement("HostOrderID")
				orderNode.appendChild childNode
				childNode.Text = strHostOrderId
				
				'set local order id
				Set childNode = responseDoc.createElement("LocalOrderID")
				orderNode.appendChild childNode
				childNode.Text = strLocalOrderId
				
				'set local order ref
				Set childNode = responseDoc.createElement("LocalOrderRef")
				orderNode.appendChild childNode
				childNode.Text = strLocalOrderRef
				
				'set host status
				Set childNode = responseDoc.createElement("HostStatus")
				orderNode.appendChild childNode
				If rowsAffected >= 1 Then
					childNode.Text = "Success"
					noOfOrdersUpdated = noOfOrdersUpdated + rowsAffected
				Else
					childNode.Text = "Failed"
				End If
			End If
		Next
		
		UpdateOrders = noOfOrdersUpdated
		
	End Function
	
	Private Function ValidateUser(username, password)
		on error resume next		
		Dim alladmin
		Dim rs,cnn,allDetails	
		Set rs = Server.CreateObject("ADODB.RecordSet")
		Set cnn = Server.CreateObject("ADODB.Connection")
		cnn.open sDSN			
		alladmin = "SELECT adminPassword, adminVersion, adminStoreURL FROM admin WHERE adminUser=" & "'" & username & "'"
		rs.Open alladmin,cnn,0,1
		allDetails = rs.getrows	
		cnn.Close	
		set rs = nothing
		set cnn = nothing
	
		if password <> allDetails(0,0) then
			ValidateUser = False
			Exit Function
		end if 
		STORE_NAME = allDetails(2,0)
		STORE_NAME_ID = allDetails(2,0)
		ValidateUser = True
	End Function
	
	Private Function GetOrders(orderStartNumber, limitOrderCount)
	
		Dim RequestID
		Dim StoreID
		Dim StoreName
		Dim ordersNode
		Dim orderNode
		Dim billingNode
		Dim shippingNode
		Dim creditCardNode
		Dim itemsNode
		Dim itemNode
		Dim itemOptionsNode
		Dim itemOptionNode
		Dim chargesNode
		Dim couponsNode
		Dim childNode
		Dim rsOrder
		Dim itemRS
		Dim noOfOrders
		Dim orderId
		Dim orderDateTime
		Dim orderTotal
		Dim strArray
		Dim orderCount	
		Dim allOrderItem
		
		Set ordersNode = responseDoc.createElement("Orders")
		responseDoc.documentElement.appendChild ordersNode	
			
		Dim tempSQLString
		
	   tempSQLString = "SELECT Count(*)AS cnt FROM orders WHERE (((orders.ordID)>=" & QB_ORDER_START_NUMBER & ")"
	   if QB_ORDER_START_NUMBER = 0 then
			'mysql case
			' AND (to_days(Now()) - TO_DAYS(ordDate)) <= " & QB_NUMBER_OF_DAYS   	
			if sqlserver = true then
				tempSQLString = tempSQLString & " AND (ordDate >= (DateAdd(d,-" & QB_NUMBER_OF_DAYS & ", GETDATE())))"	
			else
				tempSQLString = tempSQLString & " AND (ordDate >= (DateAdd('d',-" & QB_NUMBER_OF_DAYS & ", Date())))"  
			end if
	   End if
		tempSQLString = tempSQLString & " AND ((orders.ordStatus)IN (" & orderDownloadStatusList & "))) "
	
		Set rs = Server.CreateObject("ADODB.RecordSet")
		Set cnn = Server.CreateObject("ADODB.Connection")
		cnn.open sDSN			
		alladmin = tempSQLString	
		rs.Open alladmin,cnn,0,1
		orderCount = rs.getrows	
		cnn.Close
		set rs = nothing	
		noOfOrders = orderCount(0,0)
	
		if noOfOrders <> 0 then	
			set tempSQLString  = nothing
			tempSQLString = "SELECT Top " & QB_ORDERS_PER_RESPONSE 
			tempSQLString = tempSQLString & " o.ordExtra1 as Extra1, o.ordExtra2 as Extra2, o.ordShipExtra1 as ShipExtra1, o.ordShipExtra2 as ShipExtra2, o.ordCheckoutExtra1 as CheckoutExtra1, o.ordCheckoutExtra2 as CheckoutExtra2, o.ordDiscount as DiscountAmount, o.ordDiscountText as DiscountText, o.*, "
			tempSQLString = tempSQLString & " os.statPrivate, pp.payProvName "
			tempSQLString = tempSQLString & " FROM orders  o,  orderstatus  os, payprovider  pp "
			tempSQLString = tempSQLString & " WHERE o.ordStatus = os.statID And pp.payProvID = o.ordPayProvider "
			tempSQLString = tempSQLString & " AND ordID >=" & QB_ORDER_START_NUMBER
			
			 if QB_ORDER_START_NUMBER = 0 then
					'mysql case
					' AND (to_days(Now()) - TO_DAYS(ordDate)) <= " & QB_NUMBER_OF_DAYS   	
					if sqlserver = true then
						tempSQLString = tempSQLString & " AND (ordDate >= (DateAdd(d,-" & QB_NUMBER_OF_DAYS & ", GETDATE())))"  	  	
					else
						tempSQLString = tempSQLString & " AND (ordDate >= (DateAdd('d',-" & QB_NUMBER_OF_DAYS & ", Date())))"  	  	
					end if				
			 End if
			 tempSQLString = tempSQLString & " AND o.ordStatus IN (" & orderDownloadStatusList & ") ORDER BY ordID"
	
			Set rsOrder = Server.CreateObject("ADODB.RecordSet")			
			cnn.open sDSN
			rsOrder.Open tempSQLString,cnn,0,1		
	
			While Not rsOrder.EOF
	
				Set orderNode = responseDoc.createElement("Order")
				   ordersNode.appendChild orderNode
			
				'set order id
				Set childNode = responseDoc.createElement("OrderID")
				orderNode.appendChild childNode
				if not rsOrder.fields("ordID") = "" then				
					childNode.Text = rsOrder.fields("ordID")
				end if	        	        
	
				Set childNode = responseDoc.createElement("_Status")
				orderNode.appendChild childNode
				if not rsOrder.fields("statPrivate") = "" then				
					 childNode.Text = rsOrder.fields("statPrivate")	
				end if	  	               
	
				'set _StatusID
				Set childNode = responseDoc.createElement("_StatusID")
				orderNode.appendChild childNode
				if not rsOrder.fields("ordStatus") = "" then				
					 childNode.Text = rsOrder.fields("ordStatus")
				end if		        
				
				'set date
				Set childNode = responseDoc.createElement("Date")
				orderNode.appendChild childNode
				if not rsOrder.fields("ordDate") = "" then				
					 orderDateTime = rsOrder.fields("ordDate") 			
					If Not IsNull(orderDateTime) Then
						childNode.Text = Year(orderDateTime) & "-" & Right(CStr(Month(orderDateTime) + 100), 2) & "-" & Right(CStr(Day(orderDateTime) + 100), 2)
					End If
				End If
				
				'set time
				Set childNode = responseDoc.createElement("Time")
				orderNode.appendChild childNode
				If Not IsNull(orderDateTime) Then
					childNode.Text = Hour(orderDateTime) & ":" & Right(CStr(Minute(orderDateTime) + 100), 2) & ":" & Right(CStr(Second(orderDateTime) + 100), 2)
				End If
				
				'set timezone
				Set childNode = responseDoc.createElement("TimeZone")
				orderNode.appendChild childNode
				childNode.Text = ""	            
				
				'set Store Id
				Set childNode = responseDoc.createElement("StoreId")
				orderNode.appendChild childNode
				childNode.Text = STORE_NAME_ID
				
				'set Store Name
				Set childNode = responseDoc.createElement("StoreName")
				orderNode.appendChild childNode
				childNode.Text = STORE_NAME
				
			
				'set Comment
				if not rsOrder.fields("ordAddInfo") = "" AND NOT IsNull(rsOrder.fields("ordAddInfo")) then
					Set childNode = responseDoc.createElement("Comment")
					orderNode.appendChild childNode	        
					childNode.Text = rsOrder.fields("ordAddInfo")
				end if		        
				
				'add billing info
				Set billingNode = responseDoc.createElement("Bill")
				orderNode.appendChild billingNode
				
				'Bill Node
				'set PayMethod
				Set childNode = responseDoc.createElement("PayMethod")
				billingNode.appendChild childNode
				if not rsOrder.fields("payProvName") = "" then				
					 childNode.Text = rsOrder.fields("payProvName")
				end if		        
	
				Set childNode = responseDoc.createElement("PayStatus")
				billingNode.appendChild childNode
				if not rsOrder.fields("statPrivate") = "" then				
					 childNode.Text = rsOrder.fields("statPrivate")
				end if		        
	
				
				'set FirstName
			Dim arrLen
			Dim firstName
		  Dim lastName
			firstName = ""
			lastName = ""
			
			Set childNode = responseDoc.createElement("FirstName")
			billingNode.appendChild childNode
			
			
			'//ECT Older versions
			'if not rsOrder.fields("ordName") = "" then				
			'		strArray = Split(rsOrder.fields("ordName"), " ", -1)
			'		arrLen = Ubound(strArray)
			'		if arrLen > 1 then
			'			firstName=strArray(0) & " " & strArray(1)
			'		else
			'			firstName=strArray(0)
			'		end if
			'end if		    
			
			'//ECT v5.7.1 and above
			if not rsOrder.fields("ordName") = "" then				
				firstName=rsOrder.fields("ordName")
			end if		    
			
			childNode.Text = firstName
				
				
				
		  'set LastName
		  Set childNode = responseDoc.createElement("LastName")
		  billingNode.appendChild childNode

			'//ECT Older versions
			'if not rsOrder.fields("ordName") = "" then				
			'	lastName = Replace(rsOrder.fields("ordName"),firstName,"")
			'end if

			if not rsOrder.fields("ordLastName") = "" then				
				lastName = rsOrder.fields("ordLastName")
			end if
			childNode.Text = lastName	

			set strArray = Nothing
				
				
				if thub_company_field <> "" then
					Set childNode = responseDoc.createElement("CompanyName")
					billingNode.appendChild childNode
					if rsOrder.fields(thub_company_field) <> "" then				
						 childNode.Text = rsOrder.fields(thub_company_field)
					end if		        
				end if				


				'set Address1
				Set childNode = responseDoc.createElement("Address1")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordAddress") = "" then				
					 childNode.Text = rsOrder.fields("ordAddress")
				end if		        
				
				'set Address2
				Set childNode = responseDoc.createElement("Address2")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordAddress2") = "" then				
					 childNode.Text = rsOrder.fields("ordAddress2")
				end if		        
				'childNode.Text = ""
				
				'set ordCity
				Set childNode = responseDoc.createElement("City")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordCity") = "" then				
					 childNode.Text = rsOrder.fields("ordCity")
				end if		        
				
				'set State
				Set childNode = responseDoc.createElement("State")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordState") = "" then				
					childNode.Text = rsOrder.fields("ordState")
				end if	        
				
				'set ordCity
				Set childNode = responseDoc.createElement("Zip")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordZip") = "" then				
					childNode.Text = rsOrder.fields("ordZip")
				end if	        
				
				'set Country
				Set childNode = responseDoc.createElement("Country")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordCountry") = "" then				
					childNode.Text = rsOrder.fields("ordCountry")
				end if	        
				
				'set Email
				Set childNode = responseDoc.createElement("Email")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordEmail") = "" then				
					childNode.Text = rsOrder.fields("ordEmail")
				end if
						
				'set Phone
				Set childNode = responseDoc.createElement("Phone")
				billingNode.appendChild childNode
				if not rsOrder.fields("ordPhone") = "" then				
					childNode.Text = rsOrder.fields("ordPhone")
				end if	        
									 
				'set CreditCard	        
				if rsOrder.fields("ordCNum") <> "" then
				
					Set creditCardNode = responseDoc.createElement("CreditCard")
					billingNode.appendChild creditCardNode	        
							
					' Orders/Bill/CreditCard info
					dim ccDetails, ccSplit, ccSplitName, ccSplitNumAndDate
								
					ccDetails = rsOrder.fields("ordCNum")				
					ccSplit = Split(ccDetails, "&&", -1)						
					ccSplitNumAndDate = Split(ccSplit(0), "&", -1)
					if ubound(ccSplit) >= 1 then 			
						ccSplitName = Replace(ccSplit(1),"+"," ")		
					end if	
																	
					'set CreditCardType
					Set childNode = responseDoc.createElement("CreditCardType")
					creditCardNode.appendChild childNode				
					'childNode.Text = rsOrder.fields("ordAuthNumber")
													
					'set CreditCardCharge
					Set childNode = responseDoc.createElement("CreditCardCharge")
					creditCardNode.appendChild childNode
					childNode.Text = rsOrder.fields("ordTotal")
									
					'set ExpirationDate
					Set childNode = responseDoc.createElement("ExpirationDate")
					creditCardNode.appendChild childNode	
					if ubound(ccSplitNumAndDate) >= 1 then 				
					childNode.Text = ccSplitNumAndDate(1)
					end if
									
					'set CreditCardName
					Set childNode = responseDoc.createElement("CreditCardName")
					creditCardNode.appendChild childNode
					childNode.Text = ccSplitName
									
					'set CreditCardNumber
					Set childNode = responseDoc.createElement("CreditCardNumber")
					creditCardNode.appendChild childNode				
					childNode.Text = ccSplitNumAndDate(0)				        
					
				end if    
	
			   
				'add shipping info
				Set shippingNode = responseDoc.createElement("Ship")
				orderNode.appendChild shippingNode
				' Orders/Ship info
				'set ShipMethod
				Set childNode = responseDoc.createElement("ShipMethod")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipType") = "" then				
					 childNode.Text = rsOrder.fields("ordShipType")
				end if		       

				'------------------------------
				'set FirstName
			Dim sfirstName
		  Dim slastName
			sfirstName = ""
			slastName = ""
			
			
			Set childNode = responseDoc.createElement("FirstName")
			shippingNode.appendChild childNode
			
			'//ECT Older versions
			'if not rsOrder.fields("ordShipName") = "" then				
			'		strArray = Split(rsOrder.fields("ordShipName"), " ", -1)
			'		arrLen = Ubound(strArray)
			'		if arrLen > 1 then
			'			sfirstName=strArray(0) & " " & strArray(1)
			'		else
			'			sfirstName=strArray(0)
			'		end if
			'end if		    
      
      '//ECT v5.7.1 and above
			if not rsOrder.fields("ordShipName") = "" then				
				sfirstName = rsOrder.fields("ordShipName")
			end if		       

			childNode.Text = sfirstName 


				
		  'set LastName
		  Set childNode = responseDoc.createElement("LastName")
		  shippingNode.appendChild childNode
			'//ECT older versions
			'if not rsOrder.fields("ordShipName") = "" then				
			'	slastName = Replace(rsOrder.fields("ordShipName"),sfirstName,"")
			'end if
      
			'//ECT v5.7.1 and above
			if not rsOrder.fields("ordShipLastName") = "" then				
				slastName = rsOrder.fields("ordShipLastName")
			end if		       

			childNode.Text = slastName	

			set strArray = Nothing



				if thub_shipcompany_field <> "" then
					Set childNode = responseDoc.createElement("CompanyName")
					shippingNode.appendChild childNode
					if rsOrder.fields(thub_shipcompany_field) <> "" then				
						 childNode.Text = rsOrder.fields(thub_shipcompany_field)
					end if		        
				end if				

				
				'---------------------
				
				'set Address1
				Set childNode = responseDoc.createElement("Address1")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipAddress") = "" then				
					childNode.Text = rsOrder.fields("ordShipAddress") 
				end if		              
					
				'set Address2
				Set childNode = responseDoc.createElement("Address2")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipAddress2") = "" then				
					childNode.Text = rsOrder.fields("ordShipAddress2") 
				end if		              

				'set City
				Set childNode = responseDoc.createElement("City")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipCity") = "" then				
					childNode.Text = rsOrder.fields("ordShipCity") 
				end if	       
				
				'set State
				Set childNode = responseDoc.createElement("State")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipState") = "" then				
					childNode.Text = rsOrder.fields("ordShipState") 
				end if		        
				
				'set Zip
				Set childNode = responseDoc.createElement("Zip")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipZip") = "" then				
					childNode.Text = rsOrder.fields("ordShipZip") 
				end if	        
				
				'set Country
				Set childNode = responseDoc.createElement("Country")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordShipCountry") = "" then				
					childNode.Text = rsOrder.fields("ordShipCountry") 
				end if		        
				
				'set Email
				Set childNode = responseDoc.createElement("Email")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordEmail") = "" then				
					childNode.Text = rsOrder.fields("ordEmail")
				end if
							
				'set Phone
				Set childNode = responseDoc.createElement("Phone")
				shippingNode.appendChild childNode
				if not rsOrder.fields("ordPhone") = "" then				
					childNode.Text = rsOrder.fields("ordPhone")
				end if
							
				' get items of order	
				Dim tempCart, ispWeight				
				Set allOrderItem = Server.CreateObject("ADODB.RecordSet")			
				'tempCart = "SELECT * FROM cart WHERE cartOrderID = " & rsOrder.fields("ordID")
				tempCart = "SELECT c.*, p.pWeight  FROM cart as c, Products as p  where c.cartOrderID = " & rsOrder.fields("ordID") & "and p.pID = c.cartprodID"
				allOrderItem.Open tempCart,cnn,0,1
				
				if allOrderItem.EOF = true then	
					allOrderItem.Close			
					tempCart = "SELECT * FROM cart WHERE cartOrderID = " & rsOrder.fields("ordID")
					allOrderItem.Open tempCart,cnn,0,1
					ispWeight = false
				else
					ispWeight = true
				end if
				
				Set itemsNode = responseDoc.createElement("Items")
				orderNode.appendChild itemsNode
				While Not allOrderItem.EOF
				Dim cartDetails
					'set Item
					Set itemNode = responseDoc.createElement("Item")
					itemsNode.appendChild itemNode
					
					Dim tempAllCart
					Set cartDetails = Server.CreateObject("ADODB.RecordSet")
					tempAllCart = "SELECT * FROM cart c  LEFT JOIN cartoptions co ON c.cartID = co.coCartID WHERE cartID=" & allOrderItem.fields("cartID")
					cartDetails.Open tempAllCart,cnn,0,1
		
					Set itemOptionsNode = responseDoc.createElement("ItemOptions")			
					itemNode.appendChild itemOptionsNode
					gv_cartPriceDiff = "0					"
					While Not cartDetails.EOF
						'set itemOptionsNode						
						Set itemOptionNode = responseDoc.createElement("ItemOption")
							if not cartDetails.fields("coOptGroup") = "" then				
								itemOptionNode.setAttribute "Name", cartDetails.fields("coOptGroup")
							 else
								itemOptionNode.setAttribute "Name", ""
							end if	
							if not cartDetails.fields("coCartOption") = "" then				
								itemOptionNode.setAttribute "Value", cartDetails.fields("coCartOption")
							 else
								itemOptionNode.setAttribute "Value", ""
							end if				
						itemOptionsNode.appendChild itemOptionNode	
							if not cartDetails.fields("coPriceDiff") = "" then				
								gv_cartPriceDiff =  CDbl(gv_cartPriceDiff) +   CDbl(cartDetails.fields("coPriceDiff"))
							End If			
						cartDetails.MoveNext        
					Wend
					
					 'set item code
					Set childNode = responseDoc.createElement("ItemCode")
					itemNode.appendChild childNode
					if not allOrderItem.fields("cartProdID") = "" then				
					childNode.Text = allOrderItem.fields("cartProdID")
					end if	            
					
					'set ItemDescription
					Set childNode = responseDoc.createElement("ItemDescription")
					itemNode.appendChild childNode
					if not allOrderItem.fields("cartProdName") = "" then				
					childNode.Text = allOrderItem.fields("cartProdName")
					end if	            
					
					'set Quantity
					Set childNode = responseDoc.createElement("Quantity")
					itemNode.appendChild childNode
					if not allOrderItem.fields("cartQuantity") = "" then				
					childNode.Text = allOrderItem.fields("cartQuantity")
					end if
									
					'set UnitPrice
					Set childNode = responseDoc.createElement("UnitPrice")
					itemNode.appendChild childNode
					childNode.Text =  CDbl(allOrderItem.fields("cartProdPrice")) +  CDbl(gv_cartPriceDiff)
					
					'set ItemTotal
					Set childNode = responseDoc.createElement("ItemTotal")
					itemNode.appendChild childNode
					childNode.Text = (CDbl(allOrderItem.fields("cartProdPrice")) + CDbl(gv_cartPriceDiff)) * CDbl(allOrderItem.fields("cartQuantity"))
					
					'set ItemUnitWeight
					if ispWeight then
						Set childNode = responseDoc.createElement("ItemUnitWeight")
						itemNode.appendChild childNode
						childNode.Text = CDbl(allOrderItem.fields("pWeight")) 
					end if
					
					set itemOptionsNode = nothing
				
				allOrderItem.MoveNext        
				Wend	
				
				'add charges
				Set chargesNode = responseDoc.createElement("Charges")
				orderNode.appendChild chargesNode
				
				'set Tax
				Set childNode = responseDoc.createElement("Tax")
				chargesNode.appendChild childNode
				if rsOrder.fields("ordStateTax") <> "" or rsOrder.fields("ordCountryTax") <> "" or rsOrder.fields("ordHSTTax") <> ""  then				
					'childNode.Text = rsOrder.fields("ordStateTax")
					childNode.Text = CDbl(rsOrder.fields("ordCountryTax")) + CDbl(rsOrder.fields("ordStateTax")) + CDbl(rsOrder.fields("ordHSTTax"))
				end if
							
			'	If rsOrder.fields("ordCountryTax") then
			'		'set TaxOther
			'		Set childNode = responseDoc.createElement("TaxOther")
			'		chargesNode.appendChild childNode
			'		childNode.Text = rsOrder.fields("ordCountryTax")
			'	End If
				
				'set Shipping
				Set childNode = responseDoc.createElement("Shipping")
				chargesNode.appendChild childNode
				if not rsOrder.fields("ordShipping") = "" then				
					childNode.Text = rsOrder.fields("ordShipping")
				end if
							
				'set Handling
				Set childNode = responseDoc.createElement("Handling")
				chargesNode.appendChild childNode
				if not rsOrder.fields("ordHandling") = "" then				
					childNode.Text = rsOrder.fields("ordHandling")
				end if
							
		  'set Discount
		  Set childNode = responseDoc.createElement("Discount")
		  chargesNode.appendChild childNode
			if rsOrder.fields("DiscountAmount") <> "" then	
					'if rsOrder.fields("DiscountText") <> "" then 	
					'	childNode.setAttribute "Name", rsOrder.fields("DiscountText")
					'end if
					childNode.Text = CDbl(rsOrder.fields("DiscountAmount"))
				end if
							
				'set Total
				Set childNode = responseDoc.createElement("Total")
				chargesNode.appendChild childNode
				childNode.Text = CDbl(rsOrder.fields("ordTotal")) + CDbl(rsOrder.fields("ordHandling")) + CDbl(rsOrder.fields("ordShipping")) + CDbl(rsOrder.fields("ordCountryTax")) + CDbl(rsOrder.fields("ordStateTax")) + CDbl(rsOrder.fields("ordHSTTax")) - CDbl(rsOrder.fields("DiscountAmount"))
				rsOrder.MoveNext        
			Wend	
			
			cnn.Close		
			Set cnn = Nothing
			Set rsOrder = Nothing	
		
			Set cnnCart = Nothing
			Set allOrderItem = Nothing
	
			Set cnnItem = Nothing
			Set cartDetails = Nothing
		end if
		
		GetOrders = noOfOrders	
	End Function
	
	Private Function UpdateOrder(strLocalOrderRef, strHostOrderId)
		Set cnn = Server.CreateObject("ADODB.Connection")
		cnn.open sDSN			
	
		Dim rowsAffected
		Dim strSQL
		
		strSQL = "UPDATE orders SET ordStatus = '" & orderCompleteStatus & "'"
		strSQL = strSQL & " WHERE idOrder = " & strHostOrderId 
		
		cnn.Execute strSQL, rowsAffected
		UpdateOrder = rowsAffected
		'UpdateOrder = 1
			cnn.Close		
			Set cnn = Nothing
	
	End Function
	
	Private Function UpdateOrderShipped(strLocalOrderRef, strHostOrderId, trackNumber, ShippedVia, ServiceUsed)
		Set cnn = Server.CreateObject("ADODB.Connection")
		cnn.open sDSN			
	
		Dim rowsAffected
		Dim strSQL
		Dim statusFlag
		If LCase(trackNumber) = LCase("BackOrder") Then
			statusFlag = orderBackOrderedStatus
		Else
			statusFlag = orderShippedStatus
		End If
			
			Dim carrierType
		If LCase(ShippedVia) = LCase("UPS") Then
			carrierType = "4"
		ElseIf LCase(ShippedVia) = LCase("USPS") Then
			carrierType = "3"
		ElseIf LCase(ShippedVia) = LCase("Fedex") Then
			carrierType = "7"
		ElseIf LCase(ShippedVia) = LCase("DHL") Then
			carrierType = "8"
		Else
			carrierType = "0"
		End If
	
			
		strSQL = "UPDATE orders SET ordStatus = '" & statusFlag & "', ordTrackNum = '" & trackNumber & "', ordShipType = '" & ServiceUsed & "', ordShipCarrier = '" & carrierType & "'"
		strSQL = strSQL & " WHERE ordID = " & strHostOrderId 
		
	
		cnn.Execute strSQL, rowsAffected
			
		UpdateOrderShipped = rowsAffected
			cnn.Close		
			Set cnn = Nothing
	
	End Function
	
	%>
	
